#import <appkit/appkit.h>
#import "Module.h"
#import "Finder.h"
#import "support.h"
#import <ctype.h>

@interface Eval: Application
{ id  transcriptWindow ;
  id  splitView ;
  id  transcriptText ;
  id  transcriptGraphics ;
  id  textScrollView ;
  id  graphicsScrollView ;
  id  msgTextField  ;
  id  prefsPanel ;
  id  findWindow ;
  char *fileName ;  // name of current file
  // module management
  id moduleBrowser ;
  id moduleComponents ;
  id modulePath ;
  id modList ;
  int openKnt ;
  // help panel's text
  id helpText ;
}

+ clearGraphics ;
+ clearText ;
+ printf: (char *) format, ... ;
+ transcriptText ;
+ graphicsView ;
- (BOOL) appAcceptsAnotherFile: sender ;
- appDidInit: sender ;
- appWillTerminate: sender ;
- awakeFromNib ;
- clearTranscriptGraphics: sender ;
- clearTranscriptText: sender ;
- finder ;
- (const char * const *) getFileList  ;
- helpText: sender ;
- message: (char *) aMsg ;
- moduleBrowser ;
- new: sender ;
- open: sender ;
- openFileInCodeBrowser:  (const char *) fName ;
- prefsPanel ;
- printFileToTranscript: (char *) fileName ;
- printPSCode: sender ;
- reopen:sender ;
- setGraphicsScrollView: sender ;
- setTextScrollView: sender ;
- showTranscript: sender ;
- showTranscript: (id) pboard userData: (const char *) uBuf error: (char **) msg ;
- transcriptText ;
- transcriptGraphics ;
- unloadAllModules: sender ;
- unloadSelectedModule: sender ;
- windowDidMove: sender ;
- windowDidResize: sender ;

@end

@interface Eval(DotH)
- buildDotH:(char *) textBuf length:(int)textLen ; 
- buildDotH:(id) pboard userData: (const char *) ud error: (char **) msg ;

@end


@interface Eval(ObjC)
- evalObjC:(id) pboard userData: (const char *) uBuf error: (char **) msg ;
- evalObjC: (char *) text length: (int) len ;
- loadFromFile: aFile ;
- loadModule: (Module *) mod ;
- loadObjC:(id) pboard userData: (const char *) uBuf error: (char **) msg ;
- loadObjC: (char *) textBuf length: (int) textLen ;
- unloadModule: (Module *) mod ;
@end

@interface Eval(PostScript)
+ ps: (char *) format, ... ;
+ startPS ;
+ stopPS ;
- evalPs: (id) pboard userData: (const char *) uBuf error: (char **) msg ;

@end

