#import <objc/Object.h>
#import "EvalString.h"

typedef enum { DOTM, DOTO, DOTA } moduleType ;

@interface Module: Object
{ EvalString *path ;      // path to .a, .o, or .m file
  EvalString *name ;      // a unique, humanly-readable name for this module
  EvalString *location ;  // for .a or .o: path of the file or directory we created 
  char **components ;     // array of char *'s with dir paths to component .o and .a files
  moduleType modType ;    // the type, i.e. DOTM,DOTO,DOTA
  BOOL loaded ;           // == YES iff currently loaded, else == NO
}

- (EvalString *) compile: (char *) filePath libs:(char **) aLibString ;
- (char **) components ;
- componentsFromList: (List *) aList ;
- (BOOL) equals: (Module *) aMod ;
- findCompilePragma: (char **) compileBuf 
         linkPragma: (char **) linkBuf
           inStream: (NXStream *) fileStream ;
- initPath:(char *)aPath ;
- load ;
- (const char *) name ;
- (const char *) path ;
- (List *) tokensFromString: (const char *) str ;
- unload ;
@end
